;The addresses and the numbers in the assembler listing are in
;decimal, and the addresses are relative to the start of the program.

000  C5       PUSH BC         ;save routine start address to IX
001  DDE1     POP  IX
003  FDCB0286 RES  0,(TV_FLAG);copy permanent attributes
007  CD4D0D   CALL 3405       ;  to temporary attributes
010  012700   LD   BC,39      ;set IX to base address of character table
013  DD09     ADD  IX,BC
015  2A4B5C   LD   HL,(VARS)  ;find first BASIC variable
018  7E       LD   A,(HL)
019  FED3     CP   211        ;return if not array s$
021  C0       RET  NZ
022  010600   LD   BC,6       ;jump over dimension information
025  09       ADD  HL,BC
026  5E       LD   E,(HL)     ;load E and D with X and Y
027  23       INC  HL         ;  co-ordinates of start position
028  56       LD   D,(HL)
029  23       INC  HL
030  7B       LD   A,E        ;create mask byte showing
031  E607     AND  7          ;  which bit of display
033  47       LD   B,A        ;  bytes is to be altered,
034  04       INC  B          ;  and store in register C
035  3E01     LD   A,1
037  0F       RRCA
038  10FD     DJNZ 037
040  4F       LD   C,A
041  CB3B     SRL  E          ;convert co-ordinates to address in display area
043  CB3B     SRL  E
045  CB3B     SRL  E
047  7A       LD   A,D
048  FEC0     CP   192        ;return if Y co-ordinate is off foot of screen
050  D0       RET  NC
051  17       RLA
052  17       RLA
053  E6E0     AND  224
055  B3       OR   E
056  5F       LD   E,A
057  7A       LD   A,D
058  1F       RRA
059  1F       RRA
060  1F       RRA
061  E618     AND  24
063  F640     OR   64
065  57       LD   D,A
066  EB       EX   DE,HL
067  1A       LD   A,(DE)      ;load character to be printed
068  13       INC  DE          ;increment pointer
069  FE80     CP   128         ;return if character had code of 128
071  C8       RET  Z
072  D5       PUSH DE
073  C5       PUSH BC          ;calculates address in
074  EB       EX   DE,HL       ;  character table of first
075  DDE5     PUSH IX          ;  column of character to
077  E1       POP  HL          ;  be printed (IX+5*ad)
078  4F       LD   C,A
079  0600     LD   B,0
081  09       ADD  HL,BC
082  09       ADD  HL,BC
083  09       ADD  HL,BC
084  09       ADD  HL,BC
085  09       ADD  HL,BC
086  EB       EX   DE,HL
087  C1       POP  BC
088  0606     LD   B,6         ;load B with number of columns
090  E5       PUSH HL          ;set attributes on screen
091  D5       PUSH DE          ;  where first column of
092  CDDB0B   CALL 3035        ;  character is to be printed
095  D1       POP  DE
096  E1       POP  HL
097  1A       LD   A,(DE)      ;load character pattern
098  D5       PUSH DE
099  05       DEC  B           ;if last column then set
100  2006     JR   NZ,108      ;  attributes on-screen
102  E5       PUSH HL
103  CDDB0B   CALL 3035        ;  and clear accumulator
106  E1       POP  HL          ;  to print blank column
107  AF       XOR  A           ;  between characters
108  04       INC  B
109  FDCB5756 BIT  2,(P_FLAG)  ;if INVERSE is set then
113  2801     JR   Z,116       ;  invert character pattern
115  2F       CPL
116  1E08     LD   E,8         ;number of rows
118  57       LD   D,A         ;store pattern in D
119  FDCB5746 BIT  0,(P_FLAG)  ;OVER?
123  280D     JR   Z,138
125  CB12     RL   D           ;(OVER=1) if pattern bit is
127  3003     JR   NC,132      ;  set then flip the bit in the display
129  7E       LD   A,(HL)
130  A9       XOR  C
131  77       LD   (HL),A
132  24       INC  H           ;move down one row
133  1D       DEC  E           ;go back for next row
134  20F5     JR   NZ,125
136  1810     JR   154
138  CB12     RL   D           ;(OVER=0) make the bit in the display
140  7E       LD   A,(HL)      ;  equal to the pattern bit
141  3003     JR   NC,146
143  B1       OR   C
144  1803     JR   149
146  2F       CPL
147  B1       OR   C
148  2F       CPL
149  77       LD   (HL),A
150  24       INC  H           ;move down one row
151  1D       DEC  E           ;go back for next row
152  20F0     JR   NZ,138
154  CB09     RRC  C           ;set mask and address for next column
156  3001     JR   NC,159
158  2C       INC  L
159  7C       LD   A,H         ;move back up 8 rows
160  D608     SUB  8
162  67       LD   H,A
163  D1       POP  DE          ;increment pointer to character table
164  13       INC  DE
165  10BA     DJNZ 097         ;next column
167  D1       POP  DE
168  3E1F     LD   A,31        ;if X co-ordinate 248 ...
170  A5       AND  L
171  FE1F     CP   31
173  2094     JR   NZ,067      ;next character
175  79       LD   A,C
176  FE40     CP   64
178  308F     JR   NC,067      ;next character
180  0E80     LD   C,128       ;... then start a new row of characters
182  2C       INC  L
183  208A     JR   NZ,067      ;if a new third of the screen
185  7C       LD   A,H         ;  then update screen address
186  C608     ADD  A,8
188  67       LD   H,A
189  E618     AND  24          ;if off foot of screen then
191  EE18     XOR  24          ;  go to top of screen
193  2080     JR   NZ,067      ;next character
195  2640     LD   H,64        ;top of screen address
197  18EB     JR   178         ;next character - jumps via 178 as 067
                               ;  is out of range

